b89c8d9e5bc51c6f0acd1b1938ad1cd540192f15
[arvados.git] / build / run-tests.sh
1 #!/bin/bash
2 # Copyright (C) The Arvados Authors. All rights reserved.
3 #
4 # SPDX-License-Identifier: AGPL-3.0
5
6 . `dirname "$(readlink -f "$0")"`/libcloud-pin.sh
7
8 COLUMNS=80
9 . `dirname "$(readlink -f "$0")"`/run-library.sh
10
11 read -rd "\000" helpmessage <<EOF
12 $(basename $0): Install and test Arvados components.
13
14 Exit non-zero if any tests fail.
15
16 Syntax:
17         $(basename $0) WORKSPACE=/path/to/arvados [options]
18
19 Options:
20
21 --skip FOO     Do not test the FOO component.
22 --only FOO     Do not test anything except the FOO component.
23 --temp DIR     Install components and dependencies under DIR instead of
24                making a new temporary directory. Implies --leave-temp.
25 --leave-temp   Do not remove GOPATH, virtualenv, and other temp dirs at exit.
26                Instead, show the path to give as --temp to reuse them in
27                subsequent invocations.
28 --repeat N     Repeat each install/test step until it succeeds N times.
29 --retry        Prompt to retry if an install or test suite fails.
30 --skip-install Do not run any install steps. Just run tests.
31                You should provide GOPATH, GEMHOME, and VENVDIR options
32                from a previous invocation if you use this option.
33 --only-install Run specific install step
34 --short        Skip (or scale down) some slow tests.
35 WORKSPACE=path Arvados source tree to test.
36 CONFIGSRC=path Dir with api server config files to copy into source tree.
37                (If none given, leave config files alone in source tree.)
38 services/api_test="TEST=test/functional/arvados/v1/collections_controller_test.rb"
39                Restrict apiserver tests to the given file
40 sdk/python_test="--test-suite test.test_keep_locator"
41                Restrict Python SDK tests to the given class
42 apps/workbench_test="TEST=test/integration/pipeline_instances_test.rb"
43                Restrict Workbench tests to the given file
44 services/arv-git-httpd_test="-check.vv"
45                Show all log messages, even when tests pass (also works
46                with services/keepstore_test etc.)
47 ARVADOS_DEBUG=1
48                Print more debug messages
49 envvar=value   Set \$envvar to value. Primarily useful for WORKSPACE,
50                *_test, and other examples shown above.
51
52 Assuming --skip-install is not given, all components are installed
53 into \$GOPATH, \$VENDIR, and \$GEMHOME before running any tests. Many
54 test suites depend on other components being installed, and installing
55 everything tends to be quicker than debugging dependencies.
56
57 As a special concession to the current CI server config, CONFIGSRC
58 defaults to $HOME/arvados-api-server if that directory exists.
59
60 More information and background:
61
62 https://arvados.org/projects/arvados/wiki/Running_tests
63
64 Available tests:
65
66 apps/workbench (*)
67 apps/workbench_units (*)
68 apps/workbench_functionals (*)
69 apps/workbench_integration (*)
70 apps/workbench_benchmark
71 apps/workbench_profile
72 cmd/arvados-client
73 doc
74 lib/cli
75 lib/cmd
76 lib/crunchstat
77 lib/dispatchcloud
78 services/api
79 services/arv-git-httpd
80 services/crunchstat
81 services/dockercleaner
82 services/fuse
83 services/health
84 services/keep-web
85 services/keepproxy
86 services/keepstore
87 services/keep-balance
88 services/login-sync
89 services/nodemanager
90 services/nodemanager_integration
91 services/crunch-run
92 services/crunch-dispatch-local
93 services/crunch-dispatch-slurm
94 services/ws
95 sdk/cli
96 sdk/pam
97 sdk/python
98 sdk/python:py3
99 sdk/ruby
100 sdk/go/arvados
101 sdk/go/arvadosclient
102 sdk/go/dispatch
103 sdk/go/keepclient
104 sdk/go/health
105 sdk/go/httpserver
106 sdk/go/manifest
107 sdk/go/blockdigest
108 sdk/go/asyncbuf
109 sdk/go/stats
110 sdk/go/crunchrunner
111 sdk/cwl
112 sdk/R
113 tools/sync-groups
114 tools/crunchstat-summary
115 tools/keep-exercise
116 tools/keep-rsync
117 tools/keep-block-check
118
119 (*) apps/workbench is shorthand for apps/workbench_units +
120     apps/workbench_functionals + apps/workbench_integration
121
122 EOF
123
124 # First make sure to remove any ARVADOS_ variables from the calling
125 # environment that could interfere with the tests.
126 unset $(env | cut -d= -f1 | grep \^ARVADOS_)
127
128 # Reset other variables that could affect our [tests'] behavior by
129 # accident.
130 GITDIR=
131 GOPATH=
132 VENVDIR=
133 VENV3DIR=
134 PYTHONPATH=
135 GEMHOME=
136 PERLINSTALLBASE=
137 R_LIBS=
138
139 short=
140 only_install=
141 temp=
142 temp_preserve=
143
144 clear_temp() {
145     if [[ -z "$temp" ]]; then
146         # we didn't even get as far as making a temp dir
147         :
148     elif [[ -z "$temp_preserve" ]]; then
149         rm -rf "$temp"
150     else
151         echo "Leaving behind temp dirs in $temp"
152     fi
153 }
154
155 fatal() {
156     clear_temp
157     echo >&2 "Fatal: $* (encountered in ${FUNCNAME[1]} at ${BASH_SOURCE[1]} line ${BASH_LINENO[0]})"
158     exit 1
159 }
160
161 exit_cleanly() {
162     trap - INT
163     create-plot-data-from-log.sh $BUILD_NUMBER "$WORKSPACE/apps/workbench/log/test.log" "$WORKSPACE/apps/workbench/log/"
164     rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
165     stop_services
166     rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
167     report_outcomes
168     clear_temp
169     exit ${#failures}
170 }
171
172 sanity_checks() {
173     ( [[ -n "$WORKSPACE" ]] && [[ -d "$WORKSPACE/services" ]] ) \
174         || fatal "WORKSPACE environment variable not set to a source directory (see: $0 --help)"
175     echo Checking dependencies:
176     echo -n 'virtualenv: '
177     virtualenv --version \
178         || fatal "No virtualenv. Try: apt-get install virtualenv (on ubuntu: python-virtualenv)"
179     echo -n 'ruby: '
180     ruby -v \
181         || fatal "No ruby. Install >=2.1.9 (using rbenv, rvm, or source)"
182     echo -n 'go: '
183     go version \
184         || fatal "No go binary. See http://golang.org/doc/install"
185     [[ $(go version) =~ go1.([0-9]+) ]] && [[ ${BASH_REMATCH[1]} -ge 8 ]] \
186         || fatal "Go >= 1.8 required. See http://golang.org/doc/install"
187     echo -n 'gcc: '
188     gcc --version | egrep ^gcc \
189         || fatal "No gcc. Try: apt-get install build-essential"
190     echo -n 'fuse.h: '
191     find /usr/include -path '*fuse/fuse.h' | egrep --max-count=1 . \
192         || fatal "No fuse/fuse.h. Try: apt-get install libfuse-dev"
193     echo -n 'gnutls.h: '
194     find /usr/include -path '*gnutls/gnutls.h' | egrep --max-count=1 . \
195         || fatal "No gnutls/gnutls.h. Try: apt-get install libgnutls28-dev"
196     echo -n 'Python2 pyconfig.h: '
197     find /usr/include -path '*/python2*/pyconfig.h' | egrep --max-count=1 . \
198         || fatal "No Python2 pyconfig.h. Try: apt-get install python2.7-dev"
199     echo -n 'Python3 pyconfig.h: '
200     find /usr/include -path '*/python3*/pyconfig.h' | egrep --max-count=1 . \
201         || fatal "No Python3 pyconfig.h. Try: apt-get install python3-dev"
202     echo -n 'nginx: '
203     PATH="$PATH:/sbin:/usr/sbin:/usr/local/sbin" nginx -v \
204         || fatal "No nginx. Try: apt-get install nginx"
205     echo -n 'perl: '
206     perl -v | grep version \
207         || fatal "No perl. Try: apt-get install perl"
208     for mod in ExtUtils::MakeMaker JSON LWP Net::SSL; do
209         echo -n "perl $mod: "
210         perl -e "use $mod; print \"\$$mod::VERSION\\n\"" \
211             || fatal "No $mod. Try: apt-get install perl-modules libcrypt-ssleay-perl libjson-perl libwww-perl"
212     done
213     echo -n 'gitolite: '
214     which gitolite \
215         || fatal "No gitolite. Try: apt-get install gitolite3"
216     echo -n 'npm: '
217     npm --version \
218         || fatal "No npm. Try: wget -O- https://nodejs.org/dist/v6.11.2/node-v6.11.2-linux-x64.tar.xz | sudo tar -C /usr/local -xJf - && sudo ln -s ../node-v6.11.2-linux-x64/bin/{node,npm} /usr/local/bin/"
219     echo -n 'cadaver: '
220     cadaver --version | grep -w cadaver \
221           || fatal "No cadaver. Try: apt-get install cadaver"
222     echo -n 'libattr1 xattr.h: '
223     find /usr/include -path '*/attr/xattr.h' | egrep --max-count=1 . \
224         || fatal "No libattr1 xattr.h. Try: apt-get install libattr1-dev"
225     echo -n 'libcurl curl.h: '
226     find /usr/include -path '*/curl/curl.h' | egrep --max-count=1 . \
227         || fatal "No libcurl curl.h. Try: apt-get install libcurl4-gnutls-dev"
228     echo -n 'libpq libpq-fe.h: '
229     find /usr/include -path '*/postgresql/libpq-fe.h' | egrep --max-count=1 . \
230         || fatal "No libpq libpq-fe.h. Try: apt-get install libpq-dev"
231     echo -n 'services/api/config/database.yml: '
232     if [[ ! -f "$WORKSPACE/services/api/config/database.yml" ]]; then
233             fatal "Please provide a database.yml file for the test suite"
234     else
235             echo "OK"
236     fi
237     echo -n 'postgresql: '
238     psql --version || fatal "No postgresql. Try: apt-get install postgresql postgresql-client-common"
239     echo -n 'phantomjs: '
240     phantomjs --version || fatal "No phantomjs. Try: apt-get install phantomjs"
241     echo -n 'xvfb: '
242     which Xvfb || fatal "No xvfb. Try: apt-get install xvfb"
243     echo -n 'graphviz: '
244     dot -V || fatal "No graphviz. Try: apt-get install graphviz"
245
246     if [[ "$NEED_SDK_R" = true ]]; then
247       # R SDK stuff
248       echo -n 'R: '
249       which R || fatal "No R. Try: apt-get install r-base"
250       echo -n 'testthat: '
251       R -q -e "library('testthat')" || fatal "No testthat. Try: apt-get install r-cran-testthat"
252       # needed for roxygen2, needed for devtools, needed for R sdk
253       pkg-config --exists libxml-2.0 || fatal "No libxml2. Try: apt-get install libxml2-dev"
254       # needed for pkgdown, builds R SDK doc pages
255       which pandoc || fatal "No pandoc. Try: apt-get install pandoc"
256     fi
257 }
258
259 rotate_logfile() {
260   # i.e.  rotate_logfile "$WORKSPACE/apps/workbench/log/" "test.log"
261   # $BUILD_NUMBER is set by Jenkins if this script is being called as part of a Jenkins run
262   if [[ -f "$1/$2" ]]; then
263     THEDATE=`date +%Y%m%d%H%M%S`
264     mv "$1/$2" "$1/$THEDATE-$BUILD_NUMBER-$2"
265     gzip "$1/$THEDATE-$BUILD_NUMBER-$2"
266   fi
267 }
268
269 declare -a failures
270 declare -A skip
271 declare -A testargs
272 skip[apps/workbench_profile]=1
273
274 while [[ -n "$1" ]]
275 do
276     arg="$1"; shift
277     case "$arg" in
278         --help)
279             echo >&2 "$helpmessage"
280             echo >&2
281             exit 1
282             ;;
283         --skip)
284             skip[$1]=1; shift
285             ;;
286         --only)
287             only="$1"; skip[$1]=""; shift
288             ;;
289         --short)
290             short=1
291             ;;
292         --skip-install)
293             only_install=nothing
294             ;;
295         --only-install)
296             only_install="$1"; shift
297             ;;
298         --temp)
299             temp="$1"; shift
300             temp_preserve=1
301             ;;
302         --leave-temp)
303             temp_preserve=1
304             ;;
305         --repeat)
306             repeat=$((${1}+0)); shift
307             ;;
308         --retry)
309             retry=1
310             ;;
311         *_test=*)
312             suite="${arg%%_test=*}"
313             args="${arg#*=}"
314             testargs["$suite"]="$args"
315             ;;
316         *=*)
317             eval export $(echo $arg | cut -d= -f1)=\"$(echo $arg | cut -d= -f2-)\"
318             ;;
319         *)
320             echo >&2 "$0: Unrecognized option: '$arg'. Try: $0 --help"
321             exit 1
322             ;;
323     esac
324 done
325
326 # R SDK installation is very slow (~360s in a clean environment) and only
327 # required when testing it. Skip that step if it is not needed.
328 NEED_SDK_R=true
329
330 if [[ ! -z "${only}" && "${only}" != "sdk/R" ]]; then
331   NEED_SDK_R=false
332 fi
333
334 if [[ ! -z "${skip}" && "${skip}" == "sdk/R" ]]; then
335   NEED_SDK_R=false
336 fi
337
338 start_services() {
339     echo 'Starting API, keepproxy, keep-web, ws, arv-git-httpd, and nginx ssl proxy...'
340     if [[ ! -d "$WORKSPACE/services/api/log" ]]; then
341         mkdir -p "$WORKSPACE/services/api/log"
342     fi
343     # Remove empty api.pid file if it exists
344     if [[ -f "$WORKSPACE/tmp/api.pid" && ! -s "$WORKSPACE/tmp/api.pid" ]]; then
345         rm -f "$WORKSPACE/tmp/api.pid"
346     fi
347     cd "$WORKSPACE" \
348         && eval $(python sdk/python/tests/run_test_server.py start --auth admin) \
349         && export ARVADOS_TEST_API_HOST="$ARVADOS_API_HOST" \
350         && export ARVADOS_TEST_API_INSTALLED="$$" \
351         && python sdk/python/tests/run_test_server.py start_keep_proxy \
352         && python sdk/python/tests/run_test_server.py start_keep-web \
353         && python sdk/python/tests/run_test_server.py start_arv-git-httpd \
354         && python sdk/python/tests/run_test_server.py start_ws \
355         && python sdk/python/tests/run_test_server.py start_nginx \
356         && (env | egrep ^ARVADOS)
357 }
358
359 stop_services() {
360     if [[ -z "$ARVADOS_TEST_API_HOST" ]]; then
361         return
362     fi
363     unset ARVADOS_TEST_API_HOST
364     cd "$WORKSPACE" \
365         && python sdk/python/tests/run_test_server.py stop_nginx \
366         && python sdk/python/tests/run_test_server.py stop_arv-git-httpd \
367         && python sdk/python/tests/run_test_server.py stop_ws \
368         && python sdk/python/tests/run_test_server.py stop_keep-web \
369         && python sdk/python/tests/run_test_server.py stop_keep_proxy \
370         && python sdk/python/tests/run_test_server.py stop
371 }
372
373 interrupt() {
374     failures+=("($(basename $0) interrupted)")
375     exit_cleanly
376 }
377 trap interrupt INT
378
379 sanity_checks
380
381 echo "WORKSPACE=$WORKSPACE"
382
383 if [[ -z "$CONFIGSRC" ]] && [[ -d "$HOME/arvados-api-server" ]]; then
384     # Jenkins expects us to use this by default.
385     CONFIGSRC="$HOME/arvados-api-server"
386 fi
387
388 # Clean up .pyc files that may exist in the workspace
389 cd "$WORKSPACE"
390 find -name '*.pyc' -delete
391
392 if [[ -z "$temp" ]]; then
393     temp="$(mktemp -d)"
394 fi
395
396 # Set up temporary install dirs (unless existing dirs were supplied)
397 for tmpdir in VENVDIR VENV3DIR GOPATH GEMHOME PERLINSTALLBASE R_LIBS
398 do
399     if [[ -z "${!tmpdir}" ]]; then
400         eval "$tmpdir"="$temp/$tmpdir"
401     fi
402     if ! [[ -d "${!tmpdir}" ]]; then
403         mkdir "${!tmpdir}" || fatal "can't create ${!tmpdir} (does $temp exist?)"
404     fi
405 done
406
407 setup_ruby_environment() {
408     if [[ -s "$HOME/.rvm/scripts/rvm" ]] ; then
409         source "$HOME/.rvm/scripts/rvm"
410         using_rvm=true
411     elif [[ -s "/usr/local/rvm/scripts/rvm" ]] ; then
412         source "/usr/local/rvm/scripts/rvm"
413         using_rvm=true
414     else
415         using_rvm=false
416     fi
417
418     if [[ "$using_rvm" == true ]]; then
419         # If rvm is in use, we can't just put separate "dependencies"
420         # and "gems-under-test" paths to GEM_PATH: passenger resets
421         # the environment to the "current gemset", which would lose
422         # our GEM_PATH and prevent our test suites from running ruby
423         # programs (for example, the Workbench test suite could not
424         # boot an API server or run arv). Instead, we have to make an
425         # rvm gemset and use it for everything.
426
427         [[ `type rvm | head -n1` == "rvm is a function" ]] \
428             || fatal 'rvm check'
429
430         # Put rvm's favorite path back in first place (overriding
431         # virtualenv, which just put itself there). Ignore rvm's
432         # complaint about not being in first place already.
433         rvm use @default 2>/dev/null
434
435         # Create (if needed) and switch to an @arvados-tests-* gemset,
436         # salting the gemset name so it doesn't interfere with
437         # concurrent builds in other workspaces. Leave the choice of
438         # ruby to the caller.
439         gemset="arvados-tests-$(echo -n "${WORKSPACE}" | md5sum | head -c16)"
440         rvm use "@${gemset}" --create \
441             || fatal 'rvm gemset setup'
442
443         rvm env
444     else
445         # When our "bundle install"s need to install new gems to
446         # satisfy dependencies, we want them to go where "gem install
447         # --user-install" would put them. (However, if the caller has
448         # already set GEM_HOME, we assume that's where dependencies
449         # should be installed, and we should leave it alone.)
450
451         if [ -z "$GEM_HOME" ]; then
452             user_gempath="$(gem env gempath)"
453             export GEM_HOME="${user_gempath%%:*}"
454         fi
455         PATH="$(gem env gemdir)/bin:$PATH"
456
457         # When we build and install our own gems, we install them in our
458         # $GEMHOME tmpdir, and we want them to be at the front of GEM_PATH and
459         # PATH so integration tests prefer them over other versions that
460         # happen to be installed in $user_gempath, system dirs, etc.
461
462         tmpdir_gem_home="$(env - PATH="$PATH" HOME="$GEMHOME" gem env gempath | cut -f1 -d:)"
463         PATH="$tmpdir_gem_home/bin:$PATH"
464         export GEM_PATH="$tmpdir_gem_home"
465
466         echo "Will install dependencies to $(gem env gemdir)"
467         echo "Will install arvados gems to $tmpdir_gem_home"
468         echo "Gem search path is GEM_PATH=$GEM_PATH"
469     fi
470     bundle config || gem install bundler \
471         || fatal 'install bundler'
472 }
473
474 with_test_gemset() {
475     if [[ "$using_rvm" == true ]]; then
476         "$@"
477     else
478         GEM_HOME="$tmpdir_gem_home" GEM_PATH="$tmpdir_gem_home" "$@"
479     fi
480 }
481
482 gem_uninstall_if_exists() {
483     if gem list "$1\$" | egrep '^\w'; then
484         gem uninstall --force --all --executables "$1"
485     fi
486 }
487
488 setup_virtualenv() {
489     local venvdest="$1"; shift
490     if ! [[ -e "$venvdest/bin/activate" ]] || ! [[ -e "$venvdest/bin/pip" ]]; then
491         virtualenv --setuptools "$@" "$venvdest" || fatal "virtualenv $venvdest failed"
492     fi
493     if [[ $("$venvdest/bin/python" --version 2>&1) =~ \ 3\.[012]\. ]]; then
494         # pip 8.0.0 dropped support for python 3.2, e.g., debian wheezy
495         "$venvdest/bin/pip" install --no-cache-dir 'setuptools>=18.5' 'pip>=7,<8'
496     else
497         "$venvdest/bin/pip" install --no-cache-dir 'setuptools>=18.5' 'pip>=7'
498     fi
499     # ubuntu1404 can't seem to install mock via tests_require, but it can do this.
500     "$venvdest/bin/pip" install --no-cache-dir 'mock>=1.0' 'pbr<1.7.0'
501 }
502
503 export PERLINSTALLBASE
504 export PERLLIB="$PERLINSTALLBASE/lib/perl5:${PERLLIB:+$PERLLIB}"
505
506 export R_LIBS
507
508 export GOPATH
509 mkdir -p "$GOPATH/src/git.curoverse.com"
510 rmdir -v --parents --ignore-fail-on-non-empty "$GOPATH/src/git.curoverse.com/arvados.git/tmp/GOPATH"
511 for d in \
512     "$GOPATH/src/git.curoverse.com/arvados.git/arvados.git" \
513     "$GOPATH/src/git.curoverse.com/arvados.git"; do
514     [[ -d "$d" ]] && rmdir "$d"
515     [[ -h "$d" ]] && rm "$d"
516 done
517 ln -vsnfT "$WORKSPACE" "$GOPATH/src/git.curoverse.com/arvados.git" \
518     || fatal "symlink failed"
519 go get -v github.com/kardianos/govendor \
520     || fatal "govendor install failed"
521 cd "$GOPATH/src/git.curoverse.com/arvados.git" \
522     || fatal
523 # Remove cached source dirs in workdir. Otherwise, they won't qualify
524 # as +missing or +external below, and we won't be able to detect that
525 # they're missing from vendor/vendor.json.
526 rm -r vendor/*/
527 go get -v -d ...
528 "$GOPATH/bin/govendor" sync \
529     || fatal "govendor sync failed"
530 [[ -z $("$GOPATH/bin/govendor" list +unused +missing +external | tee /dev/stderr) ]] \
531     || fatal "vendor/vendor.json has unused or missing dependencies -- try:
532 * govendor remove +unused
533 * govendor add +missing +external
534 "
535 cd "$WORKSPACE"
536
537
538 setup_virtualenv "$VENVDIR" --python python2.7
539 . "$VENVDIR/bin/activate"
540
541 # Needed for run_test_server.py which is used by certain (non-Python) tests.
542 pip freeze 2>/dev/null | egrep ^PyYAML= \
543     || pip install --no-cache-dir PyYAML >/dev/null \
544     || fatal "pip install PyYAML failed"
545
546 # Preinstall libcloud, because nodemanager "pip install"
547 # won't pick it up by default.
548 pip freeze 2>/dev/null | egrep ^apache-libcloud==$LIBCLOUD_PIN \
549     || pip install --pre --ignore-installed --no-cache-dir apache-libcloud>=$LIBCLOUD_PIN >/dev/null \
550     || fatal "pip install apache-libcloud failed"
551
552 # We need an unreleased (as of 2017-08-17) llfuse bugfix, otherwise our fuse test suite deadlocks.
553 pip freeze | grep -x llfuse==1.2.0 || (
554     set -e
555     yes | pip uninstall llfuse || true
556     cython --version || fatal "no cython; try sudo apt-get install cython"
557     cd "$temp"
558     (cd python-llfuse 2>/dev/null || git clone https://github.com/curoverse/python-llfuse)
559     cd python-llfuse
560     git checkout 620722fd990ea642ddb8e7412676af482c090c0c
561     git checkout setup.py
562     sed -i -e "s:'1\\.2':'1.2.0':" setup.py
563     python setup.py build_cython
564     python setup.py install --force
565 ) || fatal "llfuse fork failed"
566 pip freeze | grep -x llfuse==1.2.0 || fatal "error: installed llfuse 1.2.0 but '$(pip freeze | grep llfuse)' ???"
567
568 # Deactivate Python 2 virtualenv
569 deactivate
570
571 declare -a pythonstuff
572 pythonstuff=(
573     sdk/pam
574     sdk/python
575     sdk/python:py3
576     sdk/cwl
577     services/dockercleaner:py3
578     services/fuse
579     services/nodemanager
580     tools/crunchstat-summary
581     )
582
583 # If Python 3 is available, set up its virtualenv in $VENV3DIR.
584 # Otherwise, skip dependent tests.
585 PYTHON3=$(which python3)
586 if [[ ${?} = 0 ]]; then
587     setup_virtualenv "$VENV3DIR" --python python3
588 else
589     PYTHON3=
590     cat >&2 <<EOF
591
592 Warning: python3 could not be found. Python 3 tests will be skipped.
593
594 EOF
595 fi
596
597 # Reactivate Python 2 virtualenv
598 . "$VENVDIR/bin/activate"
599
600 # Note: this must be the last time we change PATH, otherwise rvm will
601 # whine a lot.
602 setup_ruby_environment
603
604 echo "PATH is $PATH"
605
606 if ! which bundler >/dev/null
607 then
608     gem install --user-install bundler || fatal 'Could not install bundler'
609 fi
610
611 retry() {
612     remain="${repeat}"
613     while :
614     do
615         if ${@}; then
616             if [[ "$remain" -gt 1 ]]; then
617                 remain=$((${remain}-1))
618                 title "Repeating ${remain} more times"
619             else
620                 break
621             fi
622         elif [[ "$retry" == 1 ]]; then
623             read -p 'Try again? [Y/n] ' x
624             if [[ "$x" != "y" ]] && [[ "$x" != "" ]]
625             then
626                 break
627             fi
628         else
629             break
630         fi
631     done
632 }
633
634 do_test() {
635     case "${1}" in
636         apps/workbench_units | apps/workbench_functionals | apps/workbench_integration)
637             suite=apps/workbench
638             ;;
639         services/nodemanager | services/nodemanager_integration)
640             suite=services/nodemanager_suite
641             ;;
642         *)
643             suite="${1}"
644             ;;
645     esac
646     if [[ -z "${skip[$suite]}" && -z "${skip[$1]}" && \
647                 (-z "${only}" || "${only}" == "${suite}" || \
648                  "${only}" == "${1}") ]]; then
649         retry do_test_once ${@}
650     else
651         title "Skipping ${1} tests"
652     fi
653 }
654
655 do_test_once() {
656     unset result
657
658     title "Running $1 tests"
659     timer_reset
660     if [[ "$2" == "go" ]]
661     then
662         covername="coverage-$(echo "$1" | sed -e 's/\//_/g')"
663         coverflags=("-covermode=count" "-coverprofile=$WORKSPACE/tmp/.$covername.tmp")
664         # We do "go get -t" here to catch compilation errors
665         # before trying "go test". Otherwise, coverage-reporting
666         # mode makes Go show the wrong line numbers when reporting
667         # compilation errors.
668         go get -t "git.curoverse.com/arvados.git/$1" && \
669             cd "$GOPATH/src/git.curoverse.com/arvados.git/$1" && \
670             [[ -z "$(gofmt -e -d . | tee /dev/stderr)" ]] && \
671             if [[ -n "${testargs[$1]}" ]]
672         then
673             # "go test -check.vv giturl" doesn't work, but this
674             # does:
675             go test ${short:+-short} ${testargs[$1]}
676         else
677             # The above form gets verbose even when testargs is
678             # empty, so use this form in such cases:
679             go test ${short:+-short} ${coverflags[@]} "git.curoverse.com/arvados.git/$1"
680         fi
681         result=${result:-$?}
682         if [[ -f "$WORKSPACE/tmp/.$covername.tmp" ]]
683         then
684             go tool cover -html="$WORKSPACE/tmp/.$covername.tmp" -o "$WORKSPACE/tmp/$covername.html"
685             rm "$WORKSPACE/tmp/.$covername.tmp"
686         fi
687     elif [[ "$2" == "pip" ]]
688     then
689         tries=0
690         cd "$WORKSPACE/$1" && while :
691         do
692             tries=$((${tries}+1))
693             # $3 can name a path directory for us to use, including trailing
694             # slash; e.g., the bin/ subdirectory of a virtualenv.
695             "${3}python" setup.py ${short:+--short-tests-only} test ${testargs[$1]}
696             result=$?
697             if [[ ${tries} < 3 && ${result} == 137 ]]
698             then
699                 printf '\n*****\n%s tests killed -- retrying\n*****\n\n' "$1"
700                 continue
701             else
702                 break
703             fi
704         done
705     elif [[ "$2" != "" ]]
706     then
707         "test_$2"
708     else
709         "test_$1"
710     fi
711     result=${result:-$?}
712     checkexit $result "$1 tests"
713     title "End of $1 tests (`timer`)"
714     return $result
715 }
716
717 do_install() {
718   skipit=false
719
720   if [[ -z "${only_install}" || "${only_install}" == "${1}" ]]; then
721       retry do_install_once ${@}
722   else
723       skipit=true
724   fi
725
726   if [[ "$skipit" = true ]]; then
727     title "Skipping $1 install"
728   fi
729 }
730
731 do_install_once() {
732     title "Running $1 install"
733     timer_reset
734     if [[ "$2" == "go" ]]
735     then
736         go get -t "git.curoverse.com/arvados.git/$1"
737     elif [[ "$2" == "pip" ]]
738     then
739         # $3 can name a path directory for us to use, including trailing
740         # slash; e.g., the bin/ subdirectory of a virtualenv.
741
742         # Need to change to a different directory after creating
743         # the source dist package to avoid a pip bug.
744         # see https://arvados.org/issues/5766 for details.
745
746         # Also need to install twice, because if it believes the package is
747         # already installed, pip it won't install it.  So the first "pip
748         # install" ensures that the dependencies are met, the second "pip
749         # install" ensures that we've actually installed the local package
750         # we just built.
751         cd "$WORKSPACE/$1" \
752             && "${3}python" setup.py sdist rotate --keep=1 --match .tar.gz \
753             && cd "$WORKSPACE" \
754             && "${3}pip" install --no-cache-dir --quiet "$WORKSPACE/$1/dist"/*.tar.gz \
755             && "${3}pip" install --no-cache-dir --quiet --no-deps --ignore-installed "$WORKSPACE/$1/dist"/*.tar.gz
756     elif [[ "$2" != "" ]]
757     then
758         "install_$2"
759     else
760         "install_$1"
761     fi
762     result=$?
763     checkexit $result "$1 install"
764     title "End of $1 install (`timer`)"
765     return $result
766 }
767
768 bundle_install_trylocal() {
769     (
770         set -e
771         echo "(Running bundle install --local. 'could not find package' messages are OK.)"
772         if ! bundle install --local --no-deployment; then
773             echo "(Running bundle install again, without --local.)"
774             bundle install --no-deployment
775         fi
776         bundle package --all
777     )
778 }
779
780 install_doc() {
781     cd "$WORKSPACE/doc" \
782         && bundle_install_trylocal \
783         && rm -rf .site
784 }
785 do_install doc
786
787 install_gem() {
788     gemname=$1
789     srcpath=$2
790     with_test_gemset gem_uninstall_if_exists "$gemname" \
791         && cd "$WORKSPACE/$srcpath" \
792         && bundle_install_trylocal \
793         && gem build "$gemname.gemspec" \
794         && with_test_gemset gem install --no-ri --no-rdoc $(ls -t "$gemname"-*.gem|head -n1)
795 }
796
797 install_ruby_sdk() {
798     install_gem arvados sdk/ruby
799 }
800 do_install sdk/ruby ruby_sdk
801
802 install_R_sdk() {
803   if [[ "$NEED_SDK_R" = true ]]; then
804     cd "$WORKSPACE/sdk/R" \
805        && R --quiet --vanilla --file=install_deps.R
806   fi
807 }
808 do_install sdk/R R_sdk
809
810 install_perl_sdk() {
811     cd "$WORKSPACE/sdk/perl" \
812         && perl Makefile.PL INSTALL_BASE="$PERLINSTALLBASE" \
813         && make install INSTALLDIRS=perl
814 }
815 do_install sdk/perl perl_sdk
816
817 install_cli() {
818     install_gem arvados-cli sdk/cli
819 }
820 do_install sdk/cli cli
821
822 install_login-sync() {
823     install_gem arvados-login-sync services/login-sync
824 }
825 do_install services/login-sync login-sync
826
827 # Install the Python SDK early. Various other test suites (like
828 # keepproxy) bring up run_test_server.py, which imports the arvados
829 # module. We can't actually *test* the Python SDK yet though, because
830 # its own test suite brings up some of those other programs (like
831 # keepproxy).
832 for p in "${pythonstuff[@]}"
833 do
834     dir=${p%:py3}
835     if [[ ${dir} = ${p} ]]; then
836         if [[ -z ${skip[python2]} ]]; then
837             do_install ${dir} pip
838         fi
839     elif [[ -n ${PYTHON3} ]]; then
840         if [[ -z ${skip[python3]} ]]; then
841             do_install ${dir} pip "$VENV3DIR/bin/"
842         fi
843     fi
844 done
845
846 install_apiserver() {
847     cd "$WORKSPACE/services/api" \
848         && RAILS_ENV=test bundle_install_trylocal
849
850     rm -f config/environments/test.rb
851     cp config/environments/test.rb.example config/environments/test.rb
852
853     if [ -n "$CONFIGSRC" ]
854     then
855         for f in database.yml
856         do
857             cp "$CONFIGSRC/$f" config/ || fatal "$f"
858         done
859     fi
860
861     # Clear out any lingering postgresql connections to the test
862     # database, so that we can drop it. This assumes the current user
863     # is a postgresql superuser.
864     cd "$WORKSPACE/services/api" \
865         && test_database=$(python -c "import yaml; print yaml.load(file('config/database.yml'))['test']['database']") \
866         && psql "$test_database" -c "SELECT pg_terminate_backend (pg_stat_activity.procpid::int) FROM pg_stat_activity WHERE pg_stat_activity.datname = '$test_database';" 2>/dev/null
867
868     mkdir -p "$WORKSPACE/services/api/tmp/pids"
869
870     cert="$WORKSPACE/services/api/tmp/self-signed"
871     if [[ ! -e "$cert.pem" || "$(date -r "$cert.pem" +%s)" -lt 1512659226 ]]; then
872         (
873             dir="$WORKSPACE/services/api/tmp"
874             set -ex
875             openssl req -newkey rsa:2048 -nodes -subj '/C=US/ST=State/L=City/CN=localhost' -out "$cert.csr" -keyout "$cert.key" </dev/null
876             openssl x509 -req -in "$cert.csr" -signkey "$cert.key" -out "$cert.pem" -days 3650 -extfile <(printf 'subjectAltName=DNS:localhost,DNS:::1,DNS:0.0.0.0,DNS:127.0.0.1,IP:::1,IP:0.0.0.0,IP:127.0.0.1')
877         ) || return 1
878     fi
879
880     cd "$WORKSPACE/services/api" \
881         && rm -rf tmp/git \
882         && mkdir -p tmp/git \
883         && cd tmp/git \
884         && tar xf ../../test/test.git.tar \
885         && mkdir -p internal.git \
886         && git --git-dir internal.git init \
887             || return 1
888
889     cd "$WORKSPACE/services/api" \
890         && RAILS_ENV=test bundle exec rake db:drop \
891         && RAILS_ENV=test bundle exec rake db:setup \
892         && RAILS_ENV=test bundle exec rake db:fixtures:load
893 }
894 do_install services/api apiserver
895
896 declare -a gostuff
897 gostuff=(
898     cmd/arvados-client
899     lib/cli
900     lib/cmd
901     lib/crunchstat
902     lib/dispatchcloud
903     sdk/go/arvados
904     sdk/go/arvadosclient
905     sdk/go/blockdigest
906     sdk/go/dispatch
907     sdk/go/health
908     sdk/go/httpserver
909     sdk/go/manifest
910     sdk/go/asyncbuf
911     sdk/go/crunchrunner
912     sdk/go/stats
913     services/arv-git-httpd
914     services/crunchstat
915     services/health
916     services/keep-web
917     services/keepstore
918     sdk/go/keepclient
919     services/keep-balance
920     services/keepproxy
921     services/crunch-dispatch-local
922     services/crunch-dispatch-slurm
923     services/crunch-run
924     services/ws
925     tools/keep-block-check
926     tools/keep-exercise
927     tools/keep-rsync
928     tools/sync-groups
929 )
930 for g in "${gostuff[@]}"
931 do
932     do_install "$g" go
933 done
934
935 install_workbench() {
936     cd "$WORKSPACE/apps/workbench" \
937         && mkdir -p tmp/cache \
938         && RAILS_ENV=test bundle_install_trylocal \
939         && RAILS_ENV=test RAILS_GROUPS=assets bundle exec rake npm:install
940 }
941 do_install apps/workbench workbench
942
943 unset http_proxy https_proxy no_proxy
944
945 test_doclinkchecker() {
946     (
947         set -e
948         cd "$WORKSPACE/doc"
949         ARVADOS_API_HOST=qr1hi.arvadosapi.com
950         # Make sure python-epydoc is installed or the next line won't
951         # do much good!
952         PYTHONPATH=$WORKSPACE/sdk/python/ bundle exec rake linkchecker baseurl=file://$WORKSPACE/doc/.site/ arvados_workbench_host=https://workbench.$ARVADOS_API_HOST arvados_api_host=$ARVADOS_API_HOST
953     )
954 }
955 do_test doc doclinkchecker
956
957 stop_services
958
959 test_apiserver() {
960     rm -f "$WORKSPACE/services/api/git-commit.version"
961     cd "$WORKSPACE/services/api" \
962         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test TESTOPTS=-v ${testargs[services/api]}
963 }
964 do_test services/api apiserver
965
966 # Shortcut for when we're only running apiserver tests. This saves a bit of time,
967 # because we don't need to start up the api server for subsequent tests.
968 if [ ! -z "$only" ] && [ "$only" == "services/api" ]; then
969   rotate_logfile "$WORKSPACE/services/api/log/" "test.log"
970   exit_cleanly
971 fi
972
973 start_services || { stop_services; fatal "start_services"; }
974
975 test_ruby_sdk() {
976     cd "$WORKSPACE/sdk/ruby" \
977         && bundle exec rake test TESTOPTS=-v ${testargs[sdk/ruby]}
978 }
979 do_test sdk/ruby ruby_sdk
980
981 test_R_sdk() {
982   if [[ "$NEED_SDK_R" = true ]]; then
983     cd "$WORKSPACE/sdk/R" \
984         && R --quiet --file=run_test.R
985   fi
986 }
987
988 do_test sdk/R R_sdk
989
990 test_cli() {
991     cd "$WORKSPACE/sdk/cli" \
992         && mkdir -p /tmp/keep \
993         && KEEP_LOCAL_STORE=/tmp/keep bundle exec rake test TESTOPTS=-v ${testargs[sdk/cli]}
994 }
995 do_test sdk/cli cli
996
997 test_login-sync() {
998     cd "$WORKSPACE/services/login-sync" \
999         && bundle exec rake test TESTOPTS=-v ${testargs[services/login-sync]}
1000 }
1001 do_test services/login-sync login-sync
1002
1003 test_nodemanager_integration() {
1004     cd "$WORKSPACE/services/nodemanager" \
1005         && tests/integration_test.py ${testargs[services/nodemanager_integration]}
1006 }
1007 do_test services/nodemanager_integration nodemanager_integration
1008
1009 for p in "${pythonstuff[@]}"
1010 do
1011     dir=${p%:py3}
1012     if [[ ${dir} = ${p} ]]; then
1013         if [[ -z ${skip[python2]} ]]; then
1014             do_test ${dir} pip
1015         fi
1016     elif [[ -n ${PYTHON3} ]]; then
1017         if [[ -z ${skip[python3]} ]]; then
1018             do_test ${dir} pip "$VENV3DIR/bin/"
1019         fi
1020     fi
1021 done
1022
1023 for g in "${gostuff[@]}"
1024 do
1025     do_test "$g" go
1026 done
1027
1028 test_workbench_units() {
1029     cd "$WORKSPACE/apps/workbench" \
1030         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:units TESTOPTS=-v ${testargs[apps/workbench]}
1031 }
1032 do_test apps/workbench_units workbench_units
1033
1034 test_workbench_functionals() {
1035     cd "$WORKSPACE/apps/workbench" \
1036         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:functionals TESTOPTS=-v ${testargs[apps/workbench]}
1037 }
1038 do_test apps/workbench_functionals workbench_functionals
1039
1040 test_workbench_integration() {
1041     cd "$WORKSPACE/apps/workbench" \
1042         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:integration TESTOPTS=-v ${testargs[apps/workbench]}
1043 }
1044 do_test apps/workbench_integration workbench_integration
1045
1046
1047 test_workbench_benchmark() {
1048     cd "$WORKSPACE/apps/workbench" \
1049         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:benchmark ${testargs[apps/workbench_benchmark]}
1050 }
1051 do_test apps/workbench_benchmark workbench_benchmark
1052
1053 test_workbench_profile() {
1054     cd "$WORKSPACE/apps/workbench" \
1055         && env RAILS_ENV=test ${short:+RAILS_TEST_SHORT=1} bundle exec rake test:profile ${testargs[apps/workbench_profile]}
1056 }
1057 do_test apps/workbench_profile workbench_profile
1058
1059 exit_cleanly